apiVersion: apps.gitlab.com/v1beta1
kind: GitLab
metadata:
  name: {{ template "gitlab.name" . }}
  labels:
    app.kubernetes.io/name: {{ template "gitlab.name" . }}
    helm.sh/chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
spec:
  chart:
    version: '5.8.2'
    values:
      global:
        edition: ce
        application:
          create: true
          allowClusterRoles: true
        hosts:
          domain: {{ template "gitlab.gitlab-hostname" . }}
          https: {{ .Values.ingress.gitlab.tls }}
          gitlab:
            name: {{ template "gitlab.gitlab-hostname" . }}
            https: {{ .Values.ingress.gitlab.tls }}
        ingress:
          enabled: {{ .Values.ingress.gitlab.enabled }}
          provider: nginx
          pathType: Prefix
          path: /
          configureCertmanager: false
          {{- if (eq .Values.config.clusterType "aks") }}
          class: addon-http-application-routing
          {{- else }}
          class: nginx
          {{- end }}
          annotations:
            {{- if (eq .Values.config.clusterType "aks") }}
            kubernetes.io/ingress.class: addon-http-application-routing
            {{- else }}
            kubernetes.io/ingress.class: nginx
            {{- end }}
            {{- if .Values.ingress.gitlab.tls }}
            nginx.ingress.kubernetes.io/ssl-redirect: 'true'
            {{- end }}
          tls:
            enabled: {{ .Values.ingress.gitlab.tls }}
            secretName: {{ template "gitlab.gitlab-certificate" . }}
        # psql:
        #   password:
        #     useSecret: true
        #     secret: {{ include "gitlab.name" . }}-postgres
        #     key: POSTGRES_PASSWORD
        #   host: {{ .Values.config.postgres.host | quote }}
        #   port: {{ .Values.config.postgres.port }}
        #   username: {{ .Values.config.postgres.username | quote }}
        #   database: {{ .Values.config.postgres.database | quote }}
        #   preparedStatements: false
        redis:
          password:
            enabled: true
        gitaly:
          enabled: true
          internal:
            names:
              - default
          tls:
            enabled: false
        praefect:
          enabled: false
        minio:
          enabled: {{ (not .Values.config.s3.enabled) }}
          ingress:
            enabled: {{ .Values.ingress.gitlab.enabled }}
            tls:
              enabled: {{ .Values.ingress.gitlab.tls }}
              secretName: {{ template "gitlab.gitlab-certificate" . }}
        grafana:
          enabled: false
        initialRootPassword:
          secret: gitlab-root-password
          key: admin
        appConfig:
          enableUsagePing: false
          enableSeatLink: false
          enableImpersonation: true
          defaultCanCreateGroup: true
          usernameChangingEnabled: true
          defaultTheme: {{ .Values.config.gitlab.themeId | quote }}
          defaultProjectsFeatures:
            issues: true
            mergeRequests: true
            wiki: true
            snippets: true
            builds: true
          contentSecurityPolicy:
            enabled: false
            report_only: true
          object_store:
            enabled: {{ .Values.config.s3.enabled }}
            proxy_download: true
            connection:
              secret: store
              key: objectStoreConnection
          lfs:
            enabled: true
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "lfs") }}
            connection: {}
          artifacts:
            enabled: true
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "artifacts") }}
            connection: {}
          uploads:
            enabled: true
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "uploads") }}
            connection: {}
          packages:
            enabled: true
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "packages") }}
            connection: {}
          externalDiffs:
            enabled: false
            when:
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "external-diffs") }}
            connection: {}
          terraformState:
            enabled: false
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "terraform-state") }}
            connection: {}
          dependencyProxy:
            enabled: false
            proxy_download: true
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "dependency-proxy") }}
            connection: {}
          pseudonymizer:
            configMap:
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "pseudonymizer") }}
            connection: {}
          backups:
            bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "backups") }}
            tmpBucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "tmp") }}
          incomingEmail:
            enabled: false
            # address: ""
            # host: "imap.gmail.com"
            # port: 993
            # ssl: true
            # startTls: false
            # user: ""
            # password:
            #   secret: ""
            #   key: password
            # expungeDeleted: false
            # logger:
            #   logPath: '/dev/stdout'
            # mailbox: inbox
            # idleTimeout: 60
          serviceDeskEmail:
            enabled: false
            # address: ""
            # host: 'imap.gmail.com'
            # port: 993
            # ssl: true
            # startTls: false
            # user: ""
            # password:
            #   secret: ""
            #   key: password
            # expungeDeleted: false
            # logger:
            #   logPath: "/dev/stdout"
            # mailbox: inbox
            # idleTimeout: 60
          ldap:
            preventSignin: false
          omniauth:
            enabled: {{ .Values.config.keycloak.enabled }}
            allowBypassTwoFactor: []
            allowSingleSignOn: ['saml']
            autoLinkLdapUser: false
            autoLinkSamlUser: true
            autoLinkUser: ['saml']
            autoSignInWithProvider: {{ .Values.config.keycloak.autoSignIn | ternary "saml" "" }}
            blockAutoCreatedUsers: false
            externalProviders: []
            syncProfileAttributes: ['email']
            syncProfileFromProvider: ['saml']
            providers:
              {{- if .Values.config.keycloak.enabled }}
              - secret: {{ template "gitlab.name" . }}-omniauth
              {{- end }}
          sentry:
            enabled: false
          smartcard:
            enabled: false
        geo:
          enabled: false
        kas:
          enabled: false
        shell:
          port: 22
        rails:
          bootsnap:
            enabled: true
        registry:
          bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "registry") }}
        pages:
          enabled: false
          # accessControl: false
          # path:
          # host:
          # port:
          # https:
          # externalHttp: []
          # externalHttps: []
          # artifactsServer: true
          # objectStore:
          #   enabled: true
          #   bucket: {{ template "gitlab.bucket-name" (dict "values" .Values "bucket" "pages") }}
          #   connection: {}
          # apiSecret: {}
        smtp:
          enabled: {{ .Values.config.smtp.enabled }}
          address: {{ .Values.config.smtp.address }}
          port: {{ .Values.config.smtp.port }}
          user_name: {{ .Values.config.smtp.user_name }}
          password:
            secret: mailgun-password
            key: password
          domain: {{ .Values.config.smtp.domain }}
          authentication: {{ .Values.config.smtp.authentication }}
        email:
          from: {{ .Values.config.email.from }}
          display_name: {{ .Values.config.email.display_name }}
          reply_to: {{ .Values.config.email.from }}
          subject_suffix: ''
          smime:
            enabled: false
            secretName: ""
            keyName: "tls.key"
            certName: "tls.crt"
        time_zone: UTC
        deployment:
          annotations: {}
        serviceAccount:
          enabled: false
          create: true
        extraEnv: {}
      certmanager-issuer:
        email: nope@nope.no
      certmanager:
        installCRDs: false
        install: false
      nginx-ingress:
        enabled: false
      prometheus:
        install: false
      redis:
        install: true
        usePasswordFile: true
      postgresql:
        install: true
      registry:
        enabled: false
        ingress:
          enabled: {{ .Values.ingress.gitlab.enabled }}
          tls:
            enabled: {{ .Values.ingress.gitlab.tls }}
            secretName: {{ template "gitlab.gitlab-certificate" . }}
      shared-secrets:
        enabled: true
        rbac:
          create: true
      gitlab:
        toolbox:
          enabled: true
          replicas: 1
        gitlab-shell:
          enabled: true
          service:
            internalPort: 2222
            type: ClusterIP
        webservice:
          ingress:
            enabled: {{ .Values.ingress.gitlab.enabled }}
            tls:
              enabled: {{ .Values.ingress.gitlab.tls }}
              secretName: {{ template "gitlab.gitlab-certificate" . }}
